
/**
Löst ein Sudoku-Rätsel

- author: Albert Wiedemann
- version: 1.0
*/
class Sudoku
{
    /** Das Sudoku-Feld */
    private var feld: [[[Int]]]
    
    /**
    Legt das Sudoku-Feld an und besetzt alle Elemente mit "alle Werte möglich" vor.
    */
    init()
    {
        // Feld gemäß Teilaufgabe a erzeugen und vorbesetzen
    }
    
    /**
    Legt das in der Aufgabe dargestellte Rätsel an.
    */
    func Vorbesetzen()
    {
        FeldelementFixieren(zeile: 0, spalte: 2, wert: 2)
        FeldelementFixieren(zeile: 1, spalte: 0, wert: 6)
        FeldelementFixieren(zeile: 1, spalte: 4, wert: 3)
        FeldelementFixieren(zeile: 2, spalte: 0, wert: 4)
        FeldelementFixieren(zeile: 2, spalte: 2, wert: 9)
        FeldelementFixieren(zeile: 2, spalte: 3, wert: 1)
        FeldelementFixieren(zeile: 2, spalte: 4, wert: 6)
        FeldelementFixieren(zeile: 2, spalte: 5, wert: 7)
        FeldelementFixieren(zeile: 2, spalte: 8, wert: 3)
        FeldelementFixieren(zeile: 3, spalte: 1, wert: 1)
        FeldelementFixieren(zeile: 4, spalte: 2, wert: 8)
        FeldelementFixieren(zeile: 4, spalte: 5, wert: 4)
        FeldelementFixieren(zeile: 4, spalte: 6, wert: 3)
        FeldelementFixieren(zeile: 4, spalte: 8, wert: 2)
        FeldelementFixieren(zeile: 5, spalte: 6, wert: 4)
        FeldelementFixieren(zeile: 5, spalte: 7, wert: 7)
        FeldelementFixieren(zeile: 6, spalte: 1, wert: 8)
        FeldelementFixieren(zeile: 6, spalte: 4, wert: 9)
        FeldelementFixieren(zeile: 7, spalte: 4, wert: 4)
        FeldelementFixieren(zeile: 7, spalte: 5, wert: 3)
        FeldelementFixieren(zeile: 7, spalte: 8, wert: 8)
        FeldelementFixieren(zeile: 8, spalte: 3, wert: 5)
        FeldelementFixieren(zeile: 8, spalte: 4, wert: 7)
        FeldelementFixieren(zeile: 8, spalte: 6, wert: 9)
    }
    
    /**
	Gibt das Sudoku-Feld auf der Konsole aus
	Angegeben werden die eindeutigen Felder, sonst "-"
    */
    func FeldAusgeben()
    {
        // Rumpf gemäß Teilaufgabe c erstellen
    }

	/**
	Legt das Feldelement auf den angegebenen Wert fest.
	- parameters:
		- zeile: Zeilennummer des zu fixierenden Elements
		- spalte: Spaltennummer des zu fixierenden Elements
		- wert: der Wert des Elements
    */
    func FeldelementFixieren(zeile: Int, spalte: Int, wert: Int)
    {
        // Rumpf gemäß Teilaufgabe b erstellen
    }
    
    /**
	Testet alle Möglichkeiten an der aktuellen Stelle
	- parameters:
		- aktuelleZeile: Nummer der Zeile des aktuellen Elements
		- aktuelleSpalte: Nummer der Spalte des aktuellen Elements
    */
    func SchrittAusführen(aktuelleZeile: Int, aktuelleSpalte: Int)
    {
        let startFeld = feld
        for wert in startFeld[aktuelleZeile][aktuelleSpalte]
        {
            FeldelementFixieren(zeile: aktuelleZeile, spalte: aktuelleSpalte, wert: wert)
            if (aktuelleZeile == 8) && (aktuelleSpalte == 8)
            {
                FeldAusgeben()
            }
            else
            {
                var zeile = aktuelleZeile
                var spalte = aktuelleSpalte + 1
                if spalte > 8
                {
                    spalte = 0
                    zeile += 1
                }
                SchrittAusführen(aktuelleZeile: zeile, aktuelleSpalte: spalte)
            }
            feld = startFeld
        }
    }
}
